# Source Generated with Decompyle++
# File: in.pyc (Python 1.5)

import Bladex
import InitDataField
import GameStateAux
import ObjStore

def debugPSCEvent(name, hit_entity, x, y, z, vx, vy, vz, wcx, wcy, wcz, wdx, wdy, wdz):
    print 'unhandled hit_entity:' + hit_entity + ' by:' + name
    if hit_entity == 'Player1':
        print 'player hit!!!!!!!!!!!!!!!!!!!!!!!!!!!'
    


def checkPSysTimer(partSys, time):
    partSysEnt = Bladex.GetEntity(partSys)
    partSysCheckerEnt = partSysEnt.Data.psCheckerData
    if time > partSysCheckerEnt.stopTime:
        partSysCheckerEnt.stopCheck()
        return None
    
    i = 0
    n = partSysCheckerEnt.precission
    for i in range(n):
        hitParticle = partSysEnt.GetParticleEntity()
        hitParticle.HitFunc = partSysCheckerEnt.onHitFunc
        hitParticle.ObjCTest = 1
    

Bladex.CreateTimer('partSysCheck', 0.1)

class PSysChecker:
    ObjId = ''
    onHitFunc = debugPSCEvent
    precission = 1
    
    def __init__(self):
        self.ObjId = ObjStore.GetNewId()
        ObjStore.ObjectsStore[self.ObjId] = self

    
    def __del__(self):
        del ObjStore.ObjectsStore[self.ObjId]

    
    def startCheck(self, partSys, time):
        t = Bladex.GetTime()
        self.startTime = t
        self.stopTime = t + time
        self.pSys = partSys
        InitDataField.Initialise(self.pSys)
        self.pSys.Data.psCheckerData = self
        self.pSys.TimerFunc = checkPSysTimer
        self.pSys.SubscribeToList('partSysCheck')

    
    def stopCheck(self):
        self.pSys.TimerFunc = ''
        self.pSys.RemoveFromList('partSysCheck')

    
    def persistent_id(self):
        return self.ObjId

    
    def __getstate__(self):
        return (1, self.ObjId, GameStateAux.SaveFunctionAux(self.onHitFunc), self.precission, GameStateAux.SaveNewMembers(self))

    
    def __setstate__(self, parm):
        if parm[0] == 1:
            self.ObjId = parm[1]
            ObjStore.ObjectsStore[self.ObjId] = self
            GameStateAux.LoadFunctionAux(parm[2], self, 'onHitFunc')
            self.precission = parm[3]
            GameStateAux.LoadNewMembers(self, parm[4])
        else:
            print 'PSysChecker.__setstate__() -> Version mismatch'
            self.onHitFunc = debugPSCEvent
            self.precission = 1
            self.ObjId = ObjStore.GetNewId()



def createPSysChecker():
    psChecker = PSysChecker()
    return psChecker

